diff -crN nakedmudv1.0/src/storage.c nakedmudv1.4/src/storage.c
*** nakedmudv1.0/src/storage.c	2010-11-01 15:54:17.000000000 -0500
--- nakedmudv1.4/src/storage.c	2010-11-01 15:54:18.000000000 -0500
***************
*** 126,131 ****
--- 126,136 ----
    return new_data_string(str_val, key);
  }
  
+ STORAGE_DATA    *new_data_long(long val, const char *key) {
+   char str_val[20]; sprintf(str_val, "%ld", val);
+   return new_data_string(str_val, key);
+ }
+ 
  STORAGE_DATA *new_data_double(double val, const char *key) {
    char str_val[20]; sprintf(str_val, "%lf", val);
    return new_data_string(str_val, key);
***************
*** 227,236 ****
  
  
  void write_storage_data(STORAGE_DATA *data, FILE *fl, int key_width,int indent){
-   /*
-   if(data->comment)
-     write_storage_comment(fl, data->comment, indent);
-   */
    // first, we see if we have a string value. If we do, print it
    if(*data->str_val) {
      print_key(fl, data->key, key_width, indent);
--- 232,237 ----
***************
*** 535,543 ****
  
  STORAGE_SET *storage_read(const char *fname) {
    FILE *fl = NULL;
!   // we wanted to open a file, but we couldn't ... abort
    if((fl = fopen(fname, "r")) == NULL)
!     return NULL;
    STORAGE_SET *set = parse_storage_set(fl, 0);
    fclose(fl);
    return set;
--- 536,544 ----
  
  STORAGE_SET *storage_read(const char *fname) {
    FILE *fl = NULL;
!   // we wanted to open a file, but we couldn't ... return an empty set
    if((fl = fopen(fname, "r")) == NULL)
!     return NULL;//    return new_storage_set();
    STORAGE_SET *set = parse_storage_set(fl, 0);
    fclose(fl);
    return set;
***************
*** 600,605 ****
--- 601,611 ----
    storage_put(set, new_data_int(val, key));
  }
  
+ void store_long(STORAGE_SET *set, const char *key, long val, 
+ 	       const char *comment) {
+   storage_put(set, new_data_long(val, key));
+ }
+ 
  STORAGE_SET    *read_set(STORAGE_SET *set, const char *key) {
    STORAGE_DATA *data = hashGet(set->entries, key);
    if(data) 
***************
*** 628,640 ****
  
  double read_double(STORAGE_SET *set, const char *key) {
    STORAGE_DATA *data = hashGet(set->entries, key);
!   if(data) {
!     double dbl = 0;
!     sscanf(data->str_val, "%lf", &dbl);
!     return dbl;
!   }
!   else
!     return 0;
  }
  
  int read_int(STORAGE_SET *set, const char *key) {
--- 634,641 ----
  
  double read_double(STORAGE_SET *set, const char *key) {
    STORAGE_DATA *data = hashGet(set->entries, key);
!   if(data) return atof(data->str_val);
!   else     return 0;
  }
  
  int read_int(STORAGE_SET *set, const char *key) {
***************
*** 643,648 ****
--- 644,658 ----
    else     return 0;
  }
  
+ long read_long(STORAGE_SET *set, const char *key) {
+   STORAGE_DATA *data = hashGet(set->entries, key);
+   if(data) return atol(data->str_val);
+   else     return 0;
+ }
+ 
+ bool storage_contains(STORAGE_SET *set, const char *key) {
+   return (hashGet(set->entries, key) != NULL);
+ }
  
  //
  // make a storage list out of a normal MUD list
diff -crN nakedmudv1.0/src/storage.h nakedmudv1.4/src/storage.h
*** nakedmudv1.0/src/storage.h	2010-11-01 15:54:17.000000000 -0500
--- nakedmudv1.4/src/storage.h	2010-11-01 15:54:18.000000000 -0500
***************
*** 69,74 ****
--- 69,76 ----
  		  const char *comment);
  void    store_int(STORAGE_SET *set, const char *key, int val,
  		  const char *comment);
+ void   store_long(STORAGE_SET *set, const char *key, long val,
+ 		  const char *comment);
  
  
  //
***************
*** 79,84 ****
--- 81,97 ----
  const char       *read_string(STORAGE_SET *set, const char *key);
  double            read_double(STORAGE_SET *set, const char *key);
  int                  read_int(STORAGE_SET *set, const char *key);
+ long                read_long(STORAGE_SET *set, const char *key);
+ 
+ 
+ //
+ // returns TRUE if the key exists in the set, and false if it
+ // doesn't. Note that you can read key values even if the key
+ // doesn't exist; the values will just have a default value
+ // (0 for doubles and ints, "\0" for strings, an empty list
+ // for lists).
+ //
+ bool storage_contains(STORAGE_SET *set, const char *key);
  
  
  //
diff -crN nakedmudv1.0/src/strings.c nakedmudv1.4/src/strings.c
*** nakedmudv1.0/src/strings.c	2010-11-01 15:54:17.000000000 -0500
--- nakedmudv1.4/src/strings.c	2010-11-01 15:54:18.000000000 -0500
***************
*** 87,92 ****
--- 87,115 ----
    return fStr;
  }
  
+ 
+ //
+ // pull out the argument of the specified number
+ //
+ void arg_num(const char *from, char *to, int num) {
+   int count = 1;
+ 
+   while(count < num && *from != '\0') {
+     if(isspace(*from))
+       count++;
+     from++;
+   }
+ 
+   int i;
+   // copy up to the first space
+   for(i = 0; !isspace(from[i]) && from[i] != '\0'; i++)
+     to[i] = from[i];
+ 
+   // now cap our string
+   to[i] = '\0';
+ }
+ 
+ 
  char *capitalize(char *txt)
  {
    static char buf[MAX_BUFFER];
diff -crN nakedmudv1.0/src/text_editor.c nakedmudv1.4/src/text_editor.c
*** nakedmudv1.0/src/text_editor.c	2010-11-01 15:54:17.000000000 -0500
--- nakedmudv1.4/src/text_editor.c	2010-11-01 15:54:18.000000000 -0500
***************
*** 16,25 ****
  
  // optional modules
  #ifdef MODULE_SCRIPTS
! #include "modules/scripts/script.h"
  #endif
  #ifdef MODULE_OLC
! #include "modules/olc/olc.h"
  #endif
  
  
--- 16,25 ----
  
  // optional modules
  #ifdef MODULE_SCRIPTS
! #include "scripts/script.h"
  #endif
  #ifdef MODULE_OLC
! #include "olc/olc.h"
  #endif
  
  
diff -crN nakedmudv1.0/src/time/.depend nakedmudv1.4/src/time/.depend
*** nakedmudv1.0/src/time/.depend	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv1.4/src/time/.depend	2010-11-01 15:54:18.000000000 -0500
***************
*** 0 ****
--- 1 ----
+ time.o: time.c mudtime.h
diff -crN nakedmudv1.0/src/time/module.mk nakedmudv1.4/src/time/module.mk
*** nakedmudv1.0/src/time/module.mk	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv1.4/src/time/module.mk	2010-11-01 15:54:18.000000000 -0500
***************
*** 0 ****
--- 1,2 ----
+ # the source files we will use in the build
+ SRC += time/time.c
diff -crN nakedmudv1.0/src/time/mudtime.h nakedmudv1.4/src/time/mudtime.h
*** nakedmudv1.0/src/time/mudtime.h	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv1.4/src/time/mudtime.h	2010-11-01 15:54:18.000000000 -0500
***************
*** 0 ****
--- 1,72 ----
+ #ifndef __MUDTIME_H
+ #define __MUDTIME_H
+ //*****************************************************************************
+ //
+ // mudtime.h
+ //
+ // A small module for handling time of day in the MUD.
+ //
+ //*****************************************************************************
+ 
+ //
+ // This must be put at the top of mud.h so the rest of the MUD knows that
+ // we've got the time module installed
+ // #define MODULE_TIME
+ //
+ 
+ //
+ // Set up the time module
+ //
+ void init_time();
+ 
+ 
+ //
+ // what day is it?
+ //
+ const char *get_day();
+ 
+ 
+ //
+ // what month is it?
+ //
+ const char *get_month();
+ 
+ 
+ //
+ // what hour is it
+ //
+ int get_hour();
+ 
+ 
+ //
+ // what year is it?
+ //
+ int get_year();
+ 
+ 
+ //
+ // What period of the day are we in?
+ //
+ bool is_morning();
+ bool is_afternoon();
+ bool is_evening();
+ bool is_night();
+ 
+ 
+ //
+ // Tell the character information about the time
+ // 
+ COMMAND(cmd_time);
+ 
+ 
+ //
+ // If we have the time module installed, there is the option of
+ // supplying a night description for the room, that will be shifted
+ // to when it becomes evening/night time.
+ //
+ const char *roomGetNightDesc   (ROOM_DATA *room);
+ char      **roomGetNightDescPtr(ROOM_DATA *room);
+ void        roomSetNightDesc   (ROOM_DATA *room, const char *desc);
+ 
+ 
+ #endif // __MUDTIME_H
diff -crN nakedmudv1.0/src/time/time.c nakedmudv1.4/src/time/time.c
*** nakedmudv1.0/src/time/time.c	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv1.4/src/time/time.c	2010-11-01 15:54:18.000000000 -0500
***************
*** 0 ****
--- 1,300 ----
+ //*****************************************************************************
+ //
+ // time.c
+ //
+ // A small module for handling time of day in the MUD.
+ //
+ //*****************************************************************************
+ 
+ #include "../mud.h"
+ #include "../utils.h"
+ #include "../inform.h"
+ #include "../character.h"
+ #include "../room.h"
+ #include "../event.h"
+ #include "../storage.h"
+ #include "../auxiliary.h"
+ 
+ #include "mudtime.h"
+ 
+ 
+ #define TIME_FILE   "../lib/misc/time"  // where do we keep time data?
+ #define TIME_UPDATE_DELAY    5 MINUTES  // how long is an in-game hour?
+ #define HOURS_PER_DAY               24  // how many hours are in a day?
+ #define NUM_MONTHS                   4  // how many months are in a year?
+ #define DAYS_PER_WEEK                3  // how many days are in a week?
+ #define USE_AMPM                  TRUE  // do we use the am/pm system?
+ 
+ 
+ struct month_data {
+   char *name;             // what is the name of the month?
+   int   num_days;         // how many days are in the month?
+   int   morning_starts;   // what time does morning start at?
+   int   afternoon_starts; // what time does the afternoon start at?
+   int   evening_starts;   // what times does evening start at?
+   int   night_starts;     // what time does the night start at?
+ };
+ 
+ struct day_data {
+   char *name;
+ };
+ 
+ const struct month_data month_info[NUM_MONTHS] = {
+   // month name                 days   morning   afternoon    evening   night
+   { "the month of dawn",          30,        6,         12,        18,     22 },
+   { "the month of light",         30,        4,         10,        19,     23 },
+   { "the month of the moon",      30,        6,         12,        17,     21 },
+   { "the month of twilight",      30,        5,         13,        16,     20 },
+ };
+ 
+ const struct day_data day_info[DAYS_PER_WEEK] = {
+   { "the day of work" },
+   { "the day of play" },
+   { "the day of rest" },
+ };
+ 
+ 
+ int curr_hour         = 0; // what hour is it in the day?
+ int curr_day_of_week  = 0; // what day of the week is it?
+ int curr_day_of_month = 0; // what day is it in the month?
+ int curr_month        = 0; // what month is it in the year?
+ int curr_year         = 0; // what year is it?
+ 
+ 
+ 
+ //*****************************************************************************
+ //
+ // auxiliary data
+ //
+ // the time module gives rooms the ability to have different day and night
+ // descriptions. Below are the functions required for installing this.
+ //
+ //*****************************************************************************
+ typedef struct time_aux_data {
+   char *night_desc;        // our description at night time
+ } TIME_AUX_DATA;
+ 
+ TIME_AUX_DATA *
+ newTimeAuxData() {
+   TIME_AUX_DATA *data = malloc(sizeof(TIME_AUX_DATA));
+   data->night_desc = strdup("");
+   return data;
+ }
+ 
+ void
+ deleteTimeAuxData(TIME_AUX_DATA *data) {
+   if(data->night_desc) free(data->night_desc);
+   free(data);
+ }
+ 
+ void
+ timeAuxDataCopyTo(TIME_AUX_DATA *from, TIME_AUX_DATA *to) {
+   if(to->night_desc) free(to->night_desc);
+   to->night_desc = strdup(from->night_desc ? from->night_desc : "");
+ }
+ 
+ TIME_AUX_DATA *
+ timeAuxDataCopy(TIME_AUX_DATA *data) {
+   TIME_AUX_DATA *newdata = newTimeAuxData();
+   timeAuxDataCopyTo(data, newdata);
+   return newdata;
+ }
+ 
+ STORAGE_SET *timeAuxDataStore(TIME_AUX_DATA *data) {
+   STORAGE_SET *set = new_storage_set();
+   store_string(set, "night_desc", data->night_desc, NULL);
+   return set;
+ }
+ 
+ TIME_AUX_DATA *timeAuxDataRead(STORAGE_SET *set) {
+   TIME_AUX_DATA *data = malloc(sizeof(TIME_AUX_DATA));
+   data->night_desc = strdup(read_string(set, "night_desc"));
+   return data;
+ }
+ 
+ const char *roomGetNightDesc(ROOM_DATA *room) {
+   TIME_AUX_DATA *data = roomGetAuxiliaryData(room, "time_aux_data");
+   return data->night_desc;
+ }
+ 
+ char **roomGetNightDescPtr(ROOM_DATA *room) {
+   TIME_AUX_DATA *data = roomGetAuxiliaryData(room, "time_aux_data");
+   return &(data->night_desc);
+ }
+ 
+ void roomSetNightDesc(ROOM_DATA *room, const char *desc) {
+   TIME_AUX_DATA *data = roomGetAuxiliaryData(room, "time_aux_data");
+   if(data->night_desc) free(data->night_desc);
+   data->night_desc = strdup(desc ? desc : "");
+ }
+ 
+ 
+ 
+ //*****************************************************************************
+ //
+ // time handling functions
+ //
+ //*****************************************************************************
+ 
+ //
+ // Handle the hourly update of our times
+ //
+ void handle_time_update(void *self, void *data, char *arg) {
+   curr_hour++;
+ 
+   if(curr_hour >= HOURS_PER_DAY) {
+     curr_hour = 0;
+     curr_day_of_week++;
+     curr_day_of_month++;
+   }
+ 
+   if(curr_day_of_week >= DAYS_PER_WEEK)
+     curr_day_of_week = 0;
+ 
+   if(curr_day_of_month >= month_info[curr_month].num_days) {
+     curr_day_of_month = 0;
+     curr_month++;
+   }
+ 
+   if(curr_month >= NUM_MONTHS) {
+     curr_month = 0;
+     curr_year++;
+   }
+ 
+ 
+   // check to see if we've rolled over to a new time of day
+   if(curr_hour == month_info[curr_month].morning_starts)
+     send_outdoors("The morning sun slowly pokes its head up over the eastern horizon.\r\n");
+   if(curr_hour == month_info[curr_month].afternoon_starts)
+     send_outdoors("The sun hangs high overhead as afternoon approaches.\r\n");
+   if(curr_hour == month_info[curr_month].evening_starts)
+     send_outdoors("The sun slowly begins its descent as evening approaches.\r\n");
+   if(curr_hour == month_info[curr_month].night_starts)
+     send_outdoors("The sky goes dark as the sun passes over the western horizon.\r\n");
+ 
+   // save our time data to file
+   STORAGE_SET *set = new_storage_set();
+   store_int(set, "hour",         curr_hour,         NULL);
+   store_int(set, "day_of_week",  curr_day_of_week,  NULL);
+   store_int(set, "day_of_month", curr_day_of_month, NULL);
+   store_int(set, "month",        curr_month,        NULL);
+   store_int(set, "year",         curr_year,         NULL);
+   storage_write(set, TIME_FILE);
+   storage_close(set);
+ 
+   // throw ourself back into the event queue
+   start_event(NULL,
+ 	      TIME_UPDATE_DELAY,
+ 	      handle_time_update,
+ 	      NULL, NULL, NULL);
+ }
+ 
+ 
+ void init_time() {
+   STORAGE_SET *set  = storage_read(TIME_FILE);
+   if(set != NULL) {
+     curr_hour         = read_int(set, "hour");
+     curr_day_of_week  = read_int(set, "day_of_week");
+     curr_day_of_month = read_int(set, "day_of_month");
+     curr_month        = read_int(set, "month");
+     curr_year         = read_int(set, "year");
+     storage_close(set);
+   }
+   else
+     curr_hour = curr_day_of_week = curr_day_of_month = curr_month = curr_year = 0;
+ 
+ 
+   // add the time command
+   add_cmd("time", NULL, cmd_time, 0, POS_SITTING,  POS_FLYING,
+ 	  LEVEL_PLAYER, TRUE, FALSE);
+ 
+   // add night descriptions for rooms
+   auxiliariesInstall("time_aux_data",
+ 		     newAuxiliaryFuncs(AUXILIARY_TYPE_ROOM,
+ 				       newTimeAuxData, deleteTimeAuxData,
+ 				       timeAuxDataCopyTo, timeAuxDataCopy,
+ 				       timeAuxDataStore, timeAuxDataRead));
+ 
+   // start our time updater
+   start_event(NULL,
+ 	      TIME_UPDATE_DELAY,
+ 	      handle_time_update,
+ 	      NULL, NULL, NULL);
+ }
+ 
+ 
+ const char *get_day() {
+   return day_info[curr_day_of_week].name;
+ }
+ 
+ 
+ const char *get_month() {
+   return month_info[curr_month].name;
+ }
+ 
+ 
+ int get_year() {
+   return curr_year;
+ }
+ 
+ 
+ int get_hour() {
+   return curr_hour;
+ }
+ 
+ 
+ bool is_morning() {
+   return (curr_hour >= month_info[curr_month].morning_starts &&
+ 	  curr_hour <  month_info[curr_month].afternoon_starts);
+ }
+ 
+ 
+ bool is_afternoon() {
+   return (curr_hour >= month_info[curr_month].afternoon_starts &&
+ 	  curr_hour <  month_info[curr_month].evening_starts);
+ }
+ 
+ 
+ bool is_evening() {
+   return (curr_hour >= month_info[curr_month].evening_starts &&
+ 	  curr_hour <  month_info[curr_month].night_starts);
+ }
+ 
+ 
+ bool is_night() {
+   return (curr_hour >= month_info[curr_month].night_starts ||
+ 	  curr_hour <  month_info[curr_month].morning_starts);
+ }
+ 
+ 
+ //
+ // is it am or pm?
+ //
+ bool is_am() {
+   return (curr_hour < HOURS_PER_DAY/2);
+ }
+ 
+ 
+ //
+ // what time is it, am/pm - wise?
+ //
+ int ampm_hour() {
+   int ampm_time = curr_hour - (is_am() ? 0 : HOURS_PER_DAY/2);
+   if(ampm_time == 0) ampm_time = HOURS_PER_DAY/2;
+   return ampm_time;
+ }
+ 
+ 
+ COMMAND(cmd_time) {
+   send_to_char(ch,
+ 	       "It is %d o'clock%s during the %s of %s,\r\n"
+ 	       "which is the %d%s day of %s, year %d.\r\n",
+ 	       (USE_AMPM ? ampm_hour() : curr_hour+1),
+ 	       (USE_AMPM ? (is_am() ? " a.m" : " p.m") : ""),
+ 	       (is_morning() ? "morning" :
+ 		(is_afternoon() ? "afternoon" :
+ 		 (is_evening() ? "evening" : "night"))),
+ 	       day_info[curr_day_of_week].name,
+ 	       curr_day_of_month+1, numth(curr_day_of_month+1),
+ 	       month_info[curr_month].name, curr_year);
+ }
diff -crN nakedmudv1.0/src/utils.c nakedmudv1.4/src/utils.c
*** nakedmudv1.0/src/utils.c	2010-11-01 15:54:17.000000000 -0500
--- nakedmudv1.4/src/utils.c	2010-11-01 15:54:18.000000000 -0500
***************
*** 22,44 ****
  #include "save.h"
  #include "handler.h"
  #include "inform.h"
- #include "help.h"
  #include "dialog.h"
  #include "event.h"
  #include "action.h"
  
  
  // optional modules
- #ifdef MODULE_FACULTY
- #include "modules/faculty/faculty.h"
- #endif
- #ifdef MODULE_COMBAT
- #include "modules/combat/combat.h"
- #endif
  #ifdef MODULE_SCRIPTS
! #include "modules/scripts/script.h"
  #endif
  
  /*
   * Check to see if a given name is
   * legal, returning FALSE if it
--- 22,39 ----
  #include "save.h"
  #include "handler.h"
  #include "inform.h"
  #include "dialog.h"
  #include "event.h"
  #include "action.h"
+ #include "help.h"
  
  
  // optional modules
  #ifdef MODULE_SCRIPTS
! #include "scripts/script.h"
  #endif
  
+ 
  /*
   * Check to see if a given name is
   * legal, returning FALSE if it
***************
*** 96,104 ****
  #endif
    interrupt_events_involving(ch);
  
! #ifdef MODULE_COMBAT
    stop_all_targetting(ch);
!   stop_combat(ch);
  #endif
  
    // unequip everything the character is wearing
--- 91,99 ----
  #endif
    interrupt_events_involving(ch);
  
! #ifdef MODULE_FIGHT
    stop_all_targetting(ch);
!   stop_fight(ch);
  #endif
  
    // unequip everything the character is wearing
***************
*** 133,173 ****
    default:
      bug("Communicate: Bad Range %d.", range);
      return;
!   case COMM_LOCAL:  /* everyone in the same room */
      send_to_char(dMob, "{yYou say, '%s'{n\r\n", txt);
!     message(dMob, NULL, NULL, NULL, FALSE, TO_ROOM | TO_NOTCHAR,
! 	    "{y$n says, '%s'", txt);
      try_dialog_all(dMob, roomGetCharacters(charGetRoom(dMob)), txt);
  #ifdef MODULE_SCRIPTS
      try_speech_script(dMob, NULL, txt);
  #endif
      break;
  
!   case COMM_GLOBAL: /* everyone in the world */
      send_to_char(dMob, "{cYou chat, '%s'{n\r\n", txt);
!     message(dMob, NULL, NULL, NULL, FALSE, TO_WORLD | TO_NOTCHAR,
! 	    "{c$n chats, '%s'", txt);
      break;
  
!   case COMM_LOG: {
!     CHAR_DATA *xMob;
!     LIST_ITERATOR *mob_i = newListIterator(mobile_list);
!     ITERATE_LIST(xMob, mob_i) {
!       if (!IS_ADMIN(xMob)) continue;
!       send_to_char(xMob, "[LOG: %s]\r\n", txt);
!     }
!     deleteListIterator(mob_i);
      break;
    }
-   }
  }
  
  
  /*
   * Loading of help files, areas, etc, at boot time.
   */
! void load_muddata(bool fCopyOver)
! {  
    load_helps();
    gameworld = worldLoad(WORLD_PATH);
    if(gameworld == NULL) {
--- 128,165 ----
    default:
      bug("Communicate: Bad Range %d.", range);
      return;
! 
!   case COMM_LOCAL: {  /* everyone in the same room */
!     char other_buf[MAX_BUFFER];
!     sprintf(other_buf, "{y$n says, '%s'{n", txt);
      send_to_char(dMob, "{yYou say, '%s'{n\r\n", txt);
!     message(dMob, NULL, NULL, NULL, FALSE, TO_ROOM | TO_NOTCHAR, other_buf);
      try_dialog_all(dMob, roomGetCharacters(charGetRoom(dMob)), txt);
  #ifdef MODULE_SCRIPTS
      try_speech_script(dMob, NULL, txt);
  #endif
      break;
+   }
  
!   case COMM_GLOBAL: { /* everyone in the world */
!     char other_buf[MAX_BUFFER];
!     sprintf(other_buf, "{c$n chats, '%s'{n", txt);
      send_to_char(dMob, "{cYou chat, '%s'{n\r\n", txt);
!     message(dMob, NULL, NULL, NULL, FALSE, TO_WORLD | TO_NOTCHAR, other_buf);
      break;
+   }
  
!   case COMM_LOG:
!     send_to_level(LEVEL_ADMIN, "[LOG: %s]\r\n", txt);
      break;
    }
  }
  
  
  /*
   * Loading of help files, areas, etc, at boot time.
   */
! void load_muddata(bool fCopyOver) {  
    load_helps();
    gameworld = worldLoad(WORLD_PATH);
    if(gameworld == NULL) {
***************
*** 175,185 ****
--- 167,181 ----
      abort();
    }
  
+   greeting = read_file("../lib/txt/greeting");
+   motd     = read_file("../lib/txt/motd");
+ 
    /* copyover */
    if (fCopyOver)
      copyover_recover();
  }
  
+ 
  char *get_time()
  {
    static char buf[16];
***************
*** 329,335 ****
    return 0;
  }
  
! bool  can_see_person          ( CHAR_DATA *ch, CHAR_DATA *target) {
    if(ch == target)
      return TRUE;
    if(poscmp(charGetPos(ch), POS_SLEEPING) <= 0)
--- 325,331 ----
    return 0;
  }
  
! bool  can_see_char          ( CHAR_DATA *ch, CHAR_DATA *target) {
    if(ch == target)
      return TRUE;
    if(poscmp(charGetPos(ch), POS_SLEEPING) <= 0)
***************
*** 353,358 ****
--- 349,365 ----
    return TRUE;
  }
  
+ const char *see_char_as (CHAR_DATA *ch, CHAR_DATA *target) {
+   if(can_see_char(ch, target))
+     return charGetName(target);
+   return SOMEONE;
+ }
+ 
+ const char *see_obj_as  (CHAR_DATA *ch, OBJ_DATA  *target) {
+   if(can_see_obj(ch, target))
+     return objGetName(target);
+   return SOMETHING;
+ }
  
  int count_objs(CHAR_DATA *looker, LIST *list, const char *name, int vnum,
  	       bool must_see) {
***************
*** 382,388 ****
    int count = 0;
  
    ITERATE_LIST(ch, char_i) {
!     if(must_see && !can_see_person(looker, ch))
        continue;
      // if we have a name, search by it
      if(name && *name && charIsName(ch, name))
--- 389,395 ----
    int count = 0;
  
    ITERATE_LIST(ch, char_i) {
!     if(must_see && !can_see_char(looker, ch))
        continue;
      // if we have a name, search by it
      if(name && *name && charIsName(ch, name))
***************
*** 410,416 ****
    CHAR_DATA *ch;
  
    ITERATE_LIST(ch, char_i) {
!     if(must_see && !can_see_person(looker, ch))
        continue;
      // if we have a name, search by name
      if(name && *name && charIsName(ch, name))
--- 417,423 ----
    CHAR_DATA *ch;
  
    ITERATE_LIST(ch, char_i) {
!     if(must_see && !can_see_char(looker, ch))
        continue;
      // if we have a name, search by name
      if(name && *name && charIsName(ch, name))
***************
*** 466,472 ****
    CHAR_DATA *ch;
  
    ITERATE_LIST(ch, char_i) {
!     if(must_see && !can_see_person(looker, ch))
        continue;
      if(name && (!*name || charIsName(ch, name)))
        listPut(char_list, ch);
--- 473,479 ----
    CHAR_DATA *ch;
  
    ITERATE_LIST(ch, char_i) {
!     if(must_see && !can_see_char(looker, ch))
        continue;
      if(name && (!*name || charIsName(ch, name)))
        listPut(char_list, ch);
***************
*** 716,723 ****
      // skip all spaces and commas
      while(isspace(*keywords) || *keywords == ',')
        keywords = keywords+1;
      // see if we compare to the current keyword
!     if(!abbrev_ok && !strncasecmp(keywords, word,next_letter_in(keywords, ',')))
        return TRUE;
      if(abbrev_ok && !strncasecmp(keywords, word, word_len))
        return TRUE;
--- 723,734 ----
      // skip all spaces and commas
      while(isspace(*keywords) || *keywords == ',')
        keywords = keywords+1;
+     // figure out the length of the current keyword
+     int keyword_len = next_letter_in(keywords, ',');
+ 
      // see if we compare to the current keyword
!     if(!abbrev_ok && !strncasecmp(keywords, word, keyword_len) &&
!        keyword_len == word_len)
        return TRUE;
      if(abbrev_ok && !strncasecmp(keywords, word, word_len))
        return TRUE;
***************
*** 801,806 ****
--- 812,862 ----
  
  
  //
+ // If the keyword does not already exist, add it to the keyword list
+ // keywords may be freed and re-built in the process, to make room
+ //
+ void add_keyword(char **keywords_ptr, const char *word) {
+   // if it's already a keyword, do nothing
+   if(!is_keyword(*keywords_ptr, word, FALSE)) {
+     char buf[MAX_BUFFER];
+     // copy everything over
+     strcpy(buf, *keywords_ptr);
+     // print the new word
+     strcat(buf, ", ");
+     strcat(buf, word);
+     // free the old string
+     free(*keywords_ptr);
+     // copy the new one
+     *keywords_ptr = strdup(buf);
+   }
+ }
+ 
+ 
+ //
+ // go through the keywords and if word is found, remove it
+ //
+ void remove_keyword(char *keywords, const char *word) {
+   int i, key_i = 0, num_keywords = 0;
+   char **words = parse_keywords(keywords, &num_keywords);
+ 
+   // clear the current list... we will rebuild it
+   *keywords = '\0';
+ 
+   // go through and add them all back into keywords. If we
+   // ever encounter word, then leave it out
+   for(i = 0; i < num_keywords; i++) {
+     if(strcasecmp(words[i], word) != 0) {
+       key_i += sprintf(keywords+key_i, "%s", words[i]);
+       if(i < num_keywords-1 && strcasecmp(words[i+1], word) != 0)
+ 	key_i += sprintf(keywords+key_i, ", ");
+     }
+     free(words[i]);
+   }
+   free(words);
+ }
+ 
+ 
+ //
  // fill up the buffer with characters until
  // a newline is reached, or we hit our critical
  // length. Return how many characters were read
***************
*** 1020,1027 ****
        char *response = tagResponses(dialog,
  				    responseGetMessage(resp),
  				    "{c", "{p");
!       message(ch, listener, NULL, NULL, FALSE, TO_CHAR,
! 	      "{p$N replies, '%s'", response);
        free(response);
        return TRUE;
      }
--- 1076,1082 ----
        char *response = tagResponses(dialog,
  				    responseGetMessage(resp),
  				    "{c", "{p");
!       send_to_char(ch, "{p%s replies, '%s'\r\n", charGetName(listener), response);
        free(response);
        return TRUE;
      }
***************
*** 1205,1229 ****
    return ret_val;
  }
  
  const char *custom_prompt(CHAR_DATA *ch) {
    static char prompt[MAX_BUFFER];
    *prompt = '\0';
! 
! #ifdef MODULE_COMBAT
!   CHAR_DATA *tgt = get_target(ch);
!   if(tgt != NULL) {
!     sprintf(prompt, 
! 	    "{bMind %d, Left %d, Right %d, Feet %d, dam %d | %s :: dam %d > {n",
! 	    get_action_points(ch, FACULTY_MIND),
! 	    get_action_points(ch, FACULTY_LEFT_HAND),
! 	    get_action_points(ch, FACULTY_RIGHT_HAND),
! 	    get_action_points(ch, FACULTY_FEET),
! 	    get_damage(ch),
! 	    charGetName(tgt), get_damage(tgt));
!   }
!   else
! #endif
!     strcat(prompt, "\r\nprompt> ");
! 
    return prompt;
  }
--- 1260,1270 ----
    return ret_val;
  }
  
+ 
  const char *custom_prompt(CHAR_DATA *ch) {
    static char prompt[MAX_BUFFER];
    *prompt = '\0';
!   strcat(prompt, "\r\nprompt> ");
!     
    return prompt;
  }
diff -crN nakedmudv1.0/src/utils.h nakedmudv1.4/src/utils.h
*** nakedmudv1.0/src/utils.h	2010-11-01 15:54:17.000000000 -0500
--- nakedmudv1.4/src/utils.h	2010-11-01 15:54:18.000000000 -0500
***************
*** 42,55 ****
  #define HESHE(ch)             (charGetSex(ch) == SEX_MALE ? "he" : \
  			       (charGetSex(ch) == SEX_FEMALE ? "she" : "it"))
  
! 
! bool  can_see_person      ( CHAR_DATA *ch, CHAR_DATA *target);
  bool  can_see_obj         ( CHAR_DATA *ch, OBJ_DATA  *target);
  bool  can_see_exit        ( CHAR_DATA *ch, EXIT_DATA *exit);
  bool  try_enter_game      ( CHAR_DATA *ch);
  int   can_see_hidden      ( CHAR_DATA *ch);
  int   can_see_invis       ( CHAR_DATA *ch);
  
  bool  try_dialog          (CHAR_DATA *ch, CHAR_DATA *listener,const char *mssg);
  void  try_dialog_all      (CHAR_DATA *ch, LIST *listeners, const char *mssg);
  
--- 42,61 ----
  #define HESHE(ch)             (charGetSex(ch) == SEX_MALE ? "he" : \
  			       (charGetSex(ch) == SEX_FEMALE ? "she" : "it"))
  
! bool  can_see_char      ( CHAR_DATA *ch, CHAR_DATA *target);
  bool  can_see_obj         ( CHAR_DATA *ch, OBJ_DATA  *target);
  bool  can_see_exit        ( CHAR_DATA *ch, EXIT_DATA *exit);
  bool  try_enter_game      ( CHAR_DATA *ch);
  int   can_see_hidden      ( CHAR_DATA *ch);
  int   can_see_invis       ( CHAR_DATA *ch);
  
+ //
+ // returns the target's name if the ch can see the target,
+ // and returns SOMEONE/SOMETHING otherwise.
+ //
+ const char *see_char_as (CHAR_DATA *ch, CHAR_DATA *target);
+ const char *see_obj_as  (CHAR_DATA *ch, OBJ_DATA  *target);
+ 
  bool  try_dialog          (CHAR_DATA *ch, CHAR_DATA *listener,const char *mssg);
  void  try_dialog_all      (CHAR_DATA *ch, LIST *listeners, const char *mssg);
  
***************
*** 78,87 ****
--- 84,97 ----
  //
  //*****************************************************************************
  #define CLEAR_SCREEN      "\033[H\033[J"
+ #define AN(string)        (strchr("AEIOU", toupper(*string)) ? "an" : "a")
+ 
  char **parse_keywords     (const char *keywords, int *num_keywords);
  bool is_keyword           (const char *keywords, const char *word, 
  			   bool abbrev_ok);
  int  find_keyword         (const char *keywords, const char *string);
+ void add_keyword          (char **keywords_ptr, const char *word);
+ void remove_keyword       (char *keywords, const char *word);
  void trim                 (char *string);
  void strip_word           (char *string, const char *word);
  int  replace_string       (char **string, const char *a, const char *b, 
***************
*** 121,127 ****
        hashIteratorNext(it), \
        key = hashIteratorCurrentKey(it), val = hashIteratorCurrentVal(it))
  
! 
  
  
  //
--- 131,142 ----
        hashIteratorNext(it), \
        key = hashIteratorCurrentKey(it), val = hashIteratorCurrentVal(it))
  
! // iterate across all of the elements in a map
! #define ITERATE_MAP(key, val, it) \
!   for(key = mapIteratorCurrentKey(it), val = mapIteratorCurrentVal(it); \
!       key != NULL; \
!       mapIteratorNext(it), \
!       key = mapIteratorCurrentKey(it), val = mapIteratorCurrentVal(it))
  
  
  //
diff -crN nakedmudv1.0/src/world.c nakedmudv1.4/src/world.c
*** nakedmudv1.0/src/world.c	2010-11-01 15:54:17.000000000 -0500
--- nakedmudv1.4/src/world.c	2010-11-01 15:54:18.000000000 -0500
***************
*** 25,31 ****
  #include "world.h"
  
  #ifdef MODULE_SCRIPTS
! #include "modules/scripts/script.h"
  #endif
  
  
--- 25,31 ----
  #include "world.h"
  
  #ifdef MODULE_SCRIPTS
! #include "scripts/script.h"
  #endif
  
  
diff -crN nakedmudv1.0/src/zone.c nakedmudv1.4/src/zone.c
*** nakedmudv1.0/src/zone.c	2010-11-01 15:54:17.000000000 -0500
--- nakedmudv1.4/src/zone.c	2010-11-01 15:54:18.000000000 -0500
***************
*** 18,24 ****
  #include "dialog.h"
  
  #ifdef MODULE_SCRIPTS
! #include "modules/scripts/script.h"
  #endif
  
  
--- 18,24 ----
  #include "dialog.h"
  
  #ifdef MODULE_SCRIPTS
! #include "scripts/script.h"
  #endif
  
  
